unit eb_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, jpeg, ExtDlgs, Menus, ComCtrls,
  inifiles,Grids, Spin,Buttons;

procedure eb_wrimg(fn:string);

procedure eb_blendbmps(
  basisbmp:tbitmap;
  blendbmp:tbitmap;
  hellmode:byte;
  hellvon:integer;
  hellbis:integer;
  blendmode:byte;
  transp:integer
);
procedure eb_blend;

procedure eb_optsz;
procedure eb_orgsz;
procedure eb_zplus(step:integer);
procedure eb_zminus(step:integer);
procedure eb_ztbChange;
procedure eb_PaintBoxPaint;
procedure eb_mkpbbmp;
procedure eb_setsbs;
function eb_isempty:bool;
procedure eb_entfernen;

procedure eb_pbMouseDown(
  Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer
);
procedure eb_pbMouseMove(
  Sender: TObject;
  Shift: TShiftState;
  X,Y: Integer
);
procedure eb_pbMouseUp(
  Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer
);

implementation

uses hauptu;

//save result as jpg or bmp---------------------------
procedure eb_wrimg(fn:string);
var
  jpg:tjpegimage;
begin
  if extractfileext(fn)='' then begin
    if hauptf.eb_picwrdlg.FilterIndex=1 then
      fn:=fn+'.jpg'
    else if hauptf.eb_picwrdlg.FilterIndex=2 then
      fn:=fn+'.bmp';
  end;

  if fileexists(fn) then begin
    if application.MessageBox(
      pchar(
        'Bild "'+fn+'" existiert bereits.'+_cr+
        'Wirklich berschreiben?'
      ),
      '*** FRAGE ***',
      mb_yesno
    )=id_no then exit;
  end;

  screen.Cursor:=crhourglass;
  if lowercase(extractfileext(fn))='.bmp' then begin
    try
      hauptf.eb_bmp.SaveToFile(fn);
      hauptf.eb_bmp.Modified:=false;
      hauptf.eb_fne.Text:=fn;
    except
      application.messagebox(
        pchar(
          'Konnte Ergebnisbild "'+
          fn+
          '" nicht als Bitmap speichern!'
        ),
        '*** FEHLER **',
        mb_ok
      );
    end;
  end
  else begin
    jpg:=tjpegimage.Create;
    try
      jpg.assign(hauptf.eb_bmp);
      jpg.CompressionQuality:=70;
      try
        jpg.SaveToFile(fn);
        hauptf.eb_bmp.Modified:=false;
        hauptf.eb_fne.Text:=fn;
      except
        application.messagebox(
          pchar(
            'Konnte Ergebnisbild "'+
            fn+
            '" nicht als JPEG speichern!'
          ),
          '*** FEHLER **',
          mb_ok
        );
      end;
    finally
      jpg.Free;
    end;
  end;
  screen.Cursor:=crdefault;
end;

//---------------------------------------------------------------------------
//MERGING
//---------------------------------------------------------------------------

//merge blendbmp into basisbmp----------------------------
procedure eb_blendbmps(
  basisbmp:tbitmap;      //target and source
  blendbmp:tbitmap;      //source to merge in
  hellmode:byte;         //gray-value-mode
  hellvon:integer;       //gray-value start for hellmode
  hellbis:integer;       //gray-value end for hellmode
  blendmode:byte;        //merge-mode
  transp:integer         //strength of merging
);
var
  basishelligkeit,blendhelligkeit,
  basisgewicht,blendgewicht,
  basisr,basisg,basisb,
  blendr,blendg,blendb,
  mischr,mischg,mischb,
  x,y:integer;
  basisba,blendba:pbytearray;
  basiscol,blendcol:tcolor;
  is_hellbereich:bool;

  //convert int to byte------------
  function i2b(i:integer):byte;
  begin
    if i>255 then i:=255;
    if i<0 then i:=0;
    result:=byte(i);
  end;

begin
  blendgewicht:=transp;
  basisgewicht:=255-blendgewicht;

  for y:=0 to basisbmp.height-1 do begin

    //get line of color from source
    blendba:=blendbmp.scanline[y];

    //get line of colors from target
    basisba:=basisbmp.scanline[y];

    for x:=0 to basisbmp.width-1 do begin

      //gray-value of source
      blendr:=blendba[x*3+2];
      blendg:=blendba[x*3+1];
      blendb:=blendba[x*3+0];
      blendcol:=rgb(blendr,blendg,blendb);
      blendhelligkeit:=hauptf.col2helligkeit(blendcol);

      //acceptable gray-value?
      is_hellbereich:=
        (blendhelligkeit>=hellvon)and
        (blendhelligkeit<=hellbis);
      if
        ((hellmode=0)and not is_hellbereich)or
        ((hellmode=1)and is_hellbereich)
      then continue;

      //gray-value of target
      basisr:=basisba[x*3+2];
      basisg:=basisba[x*3+1];
      basisb:=basisba[x*3+0];
      basiscol:=rgb(basisr,basisg,basisb);
      basishelligkeit:=hauptf.col2helligkeit(basiscol);

      //do blend-mode----------------------
      mischr:=0;
      mischg:=0;
      mischb:=0;
      if blendmode=0 then begin
        //merge always
      end
      else if blendmode=1 then begin
        //merge if source is darker
        if blendhelligkeit>basishelligkeit then
          continue;
      end
      else if blendmode=2 then begin
        //merge if source is brighter
        if blendhelligkeit<basishelligkeit then
          continue;
      end
      else if blendmode=3 then begin
        //merge additiv
        mischr:=i2b((basisr*255+blendr*blendgewicht)div 255);
        mischg:=i2b((basisg*255+blendg*blendgewicht)div 255);
        mischb:=i2b((basisb*255+blendb*blendgewicht)div 255);
      end
      else if blendmode=4 then begin
        //merge subractive
        mischr:=i2b((basisr*255-blendr*blendgewicht)div 255);
        mischg:=i2b((basisg*255-blendg*blendgewicht)div 255);
        mischb:=i2b((basisb*255-blendb*blendgewicht)div 255);
      end;

      if blendmode<3 then begin
       //calculate new mix color (merge-color)
        mischr:=i2b((basisr*basisgewicht+blendr*blendgewicht)div 255);
        mischg:=i2b((basisg*basisgewicht+blendg*blendgewicht)div 255);
        mischb:=i2b((basisb*basisgewicht+blendb*blendgewicht)div 255);
      end;

      //bring new color to target
      basisba[x*3+2]:=mischr;
      basisba[x*3+1]:=mischg;
      basisba[x*3+0]:=mischb;

    end;
  end;
end;

//merge orgiginal or quad-result-bmp into result-image---------------------
procedure eb_blend;
var
  bmp:tbitmap;
begin
  if not hauptf.Visible then exit;

  screen.Cursor:=crhourglass;
  try
    //copy blend-bmp to result-bmp
    hauptf.eb_bmp.assign(hauptf.eb_blendbmp);

    if hauptf.eb_blendorgrb.checked then begin
      //merge original to result
      bmp:=hauptf.eb_orgbmp;
    end
    else begin
      //merge quader-result-pic to result
      bmp:=hauptf.eb_quadbmp;
    end;

    //do merging, adapt eb_bmp
    eb_blendbmps(
      hauptf.eb_bmp,
      bmp,
      hauptf.eb_hellmodecb.itemindex,
      hauptf.eb_hellvonsb.position,
      hauptf.eb_hellbissb.position,
      hauptf.eb_blendmodecb.itemindex,
      hauptf.eb_blendsb.Position,
    );

  finally
    screen.Cursor:=crdefault;
    hauptf.eb_pbpaint(nil);
  end;
end;

//---------------------------------------------------------------------------
//ZOOM
//---------------------------------------------------------------------------

//adapt result-bmp to paintbox---------------------------
//=> get zoom-value
procedure eb_optsz;
var
  z:double;
begin
  if
    (hauptf.eb_bmp.height/hauptf.eb_pb.Height)>
    (hauptf.eb_bmp.width/hauptf.eb_pb.width)
  then begin
    z:=(hauptf.eb_pb.height/hauptf.eb_bmp.Height);
  end
  else begin
    z:=(hauptf.eb_pb.width/hauptf.eb_bmp.width);
  end;
  hauptf.eb_ztb.position:=trunc(z*100);
  eb_ztbChange;
end;

//set result to original-size-------------------
//=> zoom-value is 100%
procedure eb_orgsz;
begin
  hauptf.eb_ztb.position:=100;
  eb_ztbChange;
end;

//zoom into result------------------------
procedure eb_zplus(step:integer);
begin
  hauptf.eb_ztb.position:=hauptf.eb_ztb.position+step;
  eb_ztbChange;
end;

//zoom out of result-----------------------
procedure eb_zminus(step:integer);
begin
  hauptf.eb_ztb.position:=hauptf.eb_ztb.position-step;
  eb_ztbChange;
end;

//adapt zoom-trackbar to zoom-value-------------
procedure eb_ztbChange;
begin
  hauptf.zl.Caption:=inttostr(hauptf.eb_ztb.position)+'%';
  eb_paintboxpaint;
end;

//transform result to paintbox-bitmap
//look at zoom-value and scroll-position
procedure eb_mkpbbmp;
var
  l,t,w,h,pw,ph:integer;
  z:double;
begin
  eb_setsbs;

  z:=hauptf.eb_ztb.position/100;

  pw:=hauptf.eb_pb.Width;
  ph:=hauptf.eb_pb.height;
  hauptf.eb_pbbmp.width:=pw;
  hauptf.eb_pbbmp.height:=ph;

  h:=round(hauptf.eb_bmp.Height*z);
  if h<ph then t:=(ph-h)div 2 else t:=0;
  if h>ph then h:=ph;
  w:=round(hauptf.eb_bmp.width*z);
  if w<pw then l:=(pw-w)div 2 else l:=0;
  if w>pw then w:=pw;

  hauptf.eb_pbbmp.canvas.pen.Color:=clsilver;
  hauptf.eb_pbbmp.canvas.brush.Color:=clsilver;
  hauptf.eb_pbbmp.canvas.Rectangle(0,0,pw,ph);
  SetStretchBltMode(
    hauptf.eb_pbbmp.canvas.handle,coloroncolor
  );
  try
    stretchblt(
      hauptf.eb_pbbmp.canvas.handle,
      l,t,w,h,
      hauptf.eb_bmp.canvas.handle,
      trunc(hauptf.eb_hsb.position/z),
      trunc(hauptf.eb_vsb.position/z),
      round(w/z),round(h/z),
      srccopy
    );
  except
  end;
end;

//paint (part of) result in dependence
//of zoom-value and scroll-positions
procedure eb_PaintBoxPaint;
begin
  try
    eb_mkpbbmp;
    bitblt(
      hauptf.eb_pb.Canvas.Handle,
      0,0,hauptf.eb_pb.width,hauptf.eb_pb.Height,
      hauptf.eb_pbbmp.canvas.handle,0,0,
      srccopy
    );
  except
  end;
end;


//set scrollbars in dependence of
//zoom-value and result dimension
procedure eb_setsbs;
var
  w,h:integer;
  sbv,sbh:tscrollbar;
  z:double;
begin
  z:=hauptf.eb_ztb.position/100;

  try
    h:=
      round(hauptf.eb_bmp.height*z)-
      hauptf.eb_pb.height;
    if h<0 then h:=0;
    w:=
      round(hauptf.eb_bmp.width*z)-
      hauptf.eb_pb.width;
    if w<0 then w:=0;

    sbv:=hauptf.eb_vsb;
    sbh:=hauptf.eb_hsb;

    sbv.Max:=h;
    sbh.max:=w;

    w:=sbv.Max div 10;if w<1 then w:=1;
    h:=sbv.Max div 10;if h<1 then h:=1;

    sbv.smallchange:=w;sbv.largechange:=w;
    sbh.smallchange:=h;sbh.largechange:=h;
  except
  end;
end;

//check if result exists---------------------
function eb_isempty:bool;
begin
  result:=(hauptf.eb_bmp.width=1);
end;

//remove actally result----------------------
procedure eb_entfernen;
begin
  hauptf.eb_fne.text:='';
  hauptf.eb_bmp.width:=1;
  hauptf.eb_bmp.height:=1;
  hauptf.eb_bmp.modified:=false;
  eb_paintboxpaint;
  hauptf.setbuttons;
end;

//click on result-bmp-------------------------------
procedure eb_pbMouseDown(
  Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer
);
begin
  if button=mbmiddle then begin
    //change size to optimum
    eb_optsz;
    exit;
  end
  else if button=mbright then begin
    //change size to original
    eb_orgsz;
    exit;
  end;

  //save actually scroll-positions
  hauptf.eb_hpos:=hauptf.eb_hsb.Position+x;
  hauptf.eb_vpos:=hauptf.eb_vsb.Position+y;
  hauptf.eb_scrollok:=true;
end;

//moving the mouse on result
procedure eb_pbMouseMove(
  Sender: TObject;
  Shift: TShiftState;
  X,Y: Integer
);
begin
  //left mousebutton down?
  if not hauptf.eb_scrollok then exit;

  //yep: scroll to new position
  hauptf.eb_hsb.Position:=(hauptf.eb_hpos-x);
  hauptf.eb_vsb.Position:=(hauptf.eb_vPos-y);
end;

//mouse button up over result
procedure eb_pbMouseUp(
  Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer
);
begin
  //disable scroll-mode
  hauptf.eb_scrollok:=false;
end;

end.

