unit op_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, jpeg, ExtDlgs, Menus, ComCtrls,
  inifiles,Grids, Spin,Buttons,math;

procedure op_updateprev;
procedure op_mkprevbmp(zbmp:tbitmap);
procedure op_picofpics;
procedure op_setebinfo;
procedure op_optthumb(Src,Dst:TBitmap);

function op_col2sgfn(col:tcolor;l,t:integer):string;
function op_sgcoldiff(col:tcolor;r,l,t:integer):int64;

implementation

uses hauptu,qp_u,ob_u,eb_u;

procedure op_updateprev;
begin
  op_mkprevbmp(nil);
  hauptf.op_prevpbPaint(nil);
end;

//set options infos------------------------------
procedure op_setebinfo;
var
  d:double;
  w,h:integer;
  sz:int64;
  s:string;
begin
  hauptf.op_qverte.Text:='';
  hauptf.op_qgesamte.Text:='';

  if ob_u.ob_isempty then exit;

  d:=hauptf.ob_bmp.width/hauptf.ob_bmp.height;

  w:=hauptf.op_qhorzse.value;
  h:=round(w/d);
  hauptf.op_qverte.Text:=inttostr(h);
  hauptf.op_qgesamte.Text:=inttostr(w*h);

  hauptf.op_pixele.Text:=
    inttostr(hauptf.op_qbreitese.value*hauptf.op_qhorzse.value)+
    ' x '+
    inttostr(hauptf.op_qbreitese.value*strtoint(hauptf.op_qverte.text));

  try
    sz:=
      hauptf.op_qbreitese.value*hauptf.op_qhorzse.value*
      hauptf.op_qbreitese.value*strtoint(hauptf.op_qverte.text)*
      3;
    if      sz>1024*1024*1024 then s:=format('%f',[sz/(1204*1024*1024)])+' GB'
    else if sz>     1024*1024 then s:=format('%f',[sz/(     1024*1024)])+' MB'
    else if sz>          1024 then s:=format('%f',[sz/(          1024)])+' KB'
    else                           s:=format('%f',[sz])+' Byte';
  except
    s:='***';
  end;

  hauptf.op_bmpsze.text:=s;
end;

//get diffenrence between col to col in quad-grid
function op_sgcoldiff(col:tcolor;r,l,t:integer):int64;
var
  cdiff:int64;
  qcol:tcolor;
  c,x,y:integer;
  pba:pbytearray;
begin
  if not hauptf.op_verlaufchb.checked then begin
    //check only middle color
    qcol:=strtoint(
      hauptf.qp_sg.cells[ord(_qp_farbe),r]
    );
    cdiff:=hauptf.getcoldiff(col,qcol);
  end
  else begin
    //check all 3 x 3 "smooth-points"
    cdiff:=0;
    c:=ord(_qp_verlauf11);
    for y:=t to t+2 do begin
      pba:=hauptf.ob_pixelbmp.ScanLine[y];
      for x:=l to l+2 do begin
        col:=hauptf.pba2col(pba,x);
        qcol:=strtoint(hauptf.qp_sg.cells[c,r]);
        cdiff:=cdiff+hauptf.getcoldiff(col,qcol);
        inc(c);
      end;
    end;
  end;
  result:=cdiff;
end;

//find best quad-file in quad-grid to a given color
function op_col2sgfn(col:tcolor;l,t:integer):string;
var
  row,cmax,cdiff,r,rr,rmax:integer;
  cdiffa:array of integer;
  rowa:array of integer;
begin
  setlength(cdiffa,hauptf.op_quaderbestse.value);
  setlength(rowa,hauptf.op_quaderbestse.value);

  row:=0;
  for r:=1 to hauptf.qp_sg.RowCount-1 do begin

    //get color difference of actually quad-entry
    cdiff:=op_sgcoldiff(col,r,l,t);

    //save best top-x of color diffs
    if row<hauptf.op_quaderbestse.value then begin
      //top-x not full: save every cdiff
      cdiffa[row]:=cdiff;
      rowa[row]:=r;
      inc(row);
    end
    else begin
      //top-x full: save only better cdiffs

      //find wirst hit in top-x
      cmax:=-1;rmax:=0;
      for rr:=0 to hauptf.op_quaderbestse.value-1 do begin
        if cdiffa[rr]>cmax then begin
          cmax:=cdiffa[rr];
          rmax:=rr;
        end;
      end;

      //new cdiff vetter then worst of top-x?
      if cdiff<cmax then begin
        //ok: replace enties
        cdiffa[rmax]:=cdiff;
        rowa[rmax]:=r;
      end;

    end;

    //Top-1-Mode?
    //Break, if there is cdiff-error=0
    if
      (hauptf.op_quaderbestse.value=1)and
      (cdiff=0)
    then break;
  end;

  //random access of top-x
  r:=random(hauptf.op_quaderbestse.value);

  //save sum of error of colors
  hauptf.op_erre.Text:=inttostr(
    strtoint64(hauptf.op_erre.Text)+
    cdiffa[r]
  );

  //return founded quad-file
  r:=rowa[r];
  result:=
    hauptf.qp_dlb.directory+'\'+
    hauptf.qp_sg.cells[ord(_qp_fn),r];
end;

//------------------------------------------------------------------
//Creates optimize Thumbs
//
//Stolen from Internet a view years ago.
//So I don't know the author of the Source.
//
//Difficult stuff! Good work, (wo)man!
//
//-------------------------------------------------------------------
procedure op_optthumb(Src,Dst:TBitmap);
type
  // Contributor for a pixel
  TContributor = record
    pixel: integer;		// Source pixel
    weight: single;		// Pixel weight
  end;

  TContributorList = array[0..0] of TContributor;
  PContributorList = ^TContributorList;

  // List of source pixels contributing to a destination pixel
  TCList = record
    n		: integer;
    p		: PContributorList;
  end;

  TCListList = array[0..0] of TCList;
  PCListList = ^TCListList;

  TRGB = packed record
    r, g, b	: single;
  end;

  // Physical bitmap pixel
  TColorRGB = packed record
    r, g, b	: BYTE;
  end;
  PColorRGB = ^TColorRGB;

  // Physical bitmap scanline (row)
  TRGBList = packed array[0..0] of TColorRGB;
  PRGBList = ^TRGBList;

var
  xscale, yscale	: single;		// Zoom scale factors
  i, j, k		: integer;		// Loop variables
  center		: single;		// Filter calculation variables
  width, fscale, weight	: single;		// Filter calculation variables
  left, right		: integer;		// Filter calculation variables
  n,cc,ccmod		: integer;		// Pixel number
  Work			: TBitmap;
  contrib		: PCListList;
  rgb			: TRGB;
  color			: TColorRGB;
  SourceLine		,
  DestLine		: PRGBList;
  SourcePixel		,
  DestPixel		: PColorRGB;
  Delta			,
  DestDelta		: integer;
  SrcWidth		,
  SrcHeight		,
  DstWidth		,
  DstHeight		: integer;
  fwidth:single;
  ok:bool;

  function Color2RGB(Color: TColor): TColorRGB;
  begin
    Result.r:=Color AND $000000FF;
    Result.g:=(Color AND $0000FF00) SHR 8;
    Result.b:=(Color AND $00FF0000) SHR 16;
  end;

  function RGB2Color(Color: TColorRGB): TColor;
  begin
    Result := Color.r OR (Color.g SHL 8) OR (Color.b SHL 16);
  end;

  function Lanczos3Filter(Value:Single):Single;

    function SinC(Value:Single):Single;
    begin
      if Value<>0.0 then begin
        Value:=Value*Pi;
        Result:=sin(Value)/Value;
      end
      else begin
        Result:=1.0;
      end;
    end;

  begin
    if Value<0.0 then Value:=-Value;
    if Value<3.0 then Result:=SinC(Value)*SinC(Value/3.0)
                 else Result:=0.0;
  end;

begin
  ok:=false;
  fwidth:=3.0;
  DstWidth:=Dst.Width;
  DstHeight:=Dst.Height;
  SrcWidth:=Src.Width;
  SrcHeight:=Src.Height;
  if (SrcWidth<1)or(SrcHeight<1) then
    raise Exception.Create('Source bitmap too small');

  // Create intermediate image to hold horizontal zoom
  Work:=TBitmap.Create;
  try
    Work.Height:=SrcHeight;
    Work.Width:=DstWidth;
    if SrcWidth=1 then xscale:=DstWidth/SrcWidth
                  else xscale:=(DstWidth-1)/(SrcWidth-1);
    if SrcHeight=1 then yscale:=DstHeight/SrcHeight
                   else yscale:=(DstHeight-1)/(SrcHeight-1);
    Src.PixelFormat:=pf24bit;
    Dst.PixelFormat:=Src.PixelFormat;
    Work.PixelFormat:=Src.PixelFormat;

    // --------------------------------------------
    // Pre-calculate filter contributions for a row
    // -----------------------------------------------
    GetMem(contrib,DstWidth*sizeof(TCList));

    // Horizontal sub-sampling
    // Scales from bigger to smaller width
    if xscale<1.0 then begin
      width:=fwidth/xscale;
      fscale:=1.0/xscale;

      for i := 0 to DstWidth-1 do begin

        contrib^[i].n := 0;
        GetMem(contrib^[i].p,trunc(width*2.0+1)*sizeof(TContributor));
        center:=i/xscale;
        // Original code:
        // left := ceil(center - width);
        // right := floor(center + width);
        left := floor(center - width);
        right := ceil(center + width);
        for j := left to right do begin
          weight := Lanczos3Filter((center - j) / fscale) / fscale;
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcWidth) then n := SrcWidth - j + SrcWidth - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end;
    end
    else begin
      // Horizontal super-sampling
      // Scales from smaller to bigger width
      for i := 0 to DstWidth-1 do begin

        contrib^[i].n := 0;
        GetMem(contrib^[i].p, trunc(fwidth * 2.0 + 1) * sizeof(TContributor));
        center := i / xscale;
        // Original code:
        // left := ceil(center - fwidth);
        // right := floor(center + fwidth);
        left := floor(center - fwidth);
        right := ceil(center + fwidth);
        for j := left to right do begin
          weight := Lanczos3Filter(center - j);
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcWidth) then n := SrcWidth - j + SrcWidth - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end;
    end;

    // ----------------------------------------------------
    // Apply filter to sample horizontally from Src to Work
    // ----------------------------------------------------

    for k:=0 to SrcHeight-1 do begin

      SourceLine:=Src.ScanLine[k];
      DestPixel:=Work.ScanLine[k];
      for i := 0 to DstWidth-1 do begin
        rgb.r := 0.0;
        rgb.g := 0.0;
        rgb.b := 0.0;
        for j := 0 to contrib^[i].n-1 do begin
          color := SourceLine^[contrib^[i].p^[j].pixel];
          weight := contrib^[i].p^[j].weight;
          if weight=0.0 then continue;
          rgb.r := rgb.r + color.r * weight;
          rgb.g := rgb.g + color.g * weight;
          rgb.b := rgb.b + color.b * weight;
        end;
        if (rgb.r > 255.0) then color.r := 255
        else if (rgb.r < 0.0) then color.r := 0
        else color.r := round(rgb.r);
        if (rgb.g > 255.0) then color.g := 255
        else if (rgb.g < 0.0) then color.g := 0
        else color.g := round(rgb.g);
        if (rgb.b > 255.0) then color.b := 255
        else if (rgb.b < 0.0) then color.b := 0
        else color.b := round(rgb.b);
        // Set new pixel value
        DestPixel^ := color;
        // Move on to next column
        inc(DestPixel);
      end;
    end;

    // Free the memory allocated for horizontal filter weights
    for i:=0 to DstWidth-1 do FreeMem(contrib^[i].p);
    FreeMem(contrib);

    // -----------------------------------------------
    // Pre-calculate filter contributions for a column
    // -----------------------------------------------
    GetMem(contrib, DstHeight* sizeof(TCList));
    // Vertical sub-sampling
    // Scales from bigger to smaller height
    if yscale<1.0 then begin
      width := fwidth / yscale;
      fscale := 1.0 / yscale;

      for i := 0 to DstHeight-1 do begin

        contrib^[i].n := 0;
        GetMem(contrib^[i].p, trunc(width * 2.0 + 1) * sizeof(TContributor));
        center := i / yscale;
        // Original code:
        // left := ceil(center - width);
        // right := floor(center + width);
        left := floor(center - width);
        right := ceil(center + width);
        for j := left to right do begin
          weight := Lanczos3Filter((center - j) / fscale) / fscale;
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcHeight) then n := SrcHeight - j + SrcHeight - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end
    end
    else begin
      // Vertical super-sampling
      // Scales from smaller to bigger height
      for i := 0 to DstHeight-1 do begin

        contrib^[i].n := 0;
        GetMem(contrib^[i].p, trunc(fwidth * 2.0 + 1) * sizeof(TContributor));
        center := i / yscale;
        // Original code:
        // left := ceil(center - fwidth);
        // right := floor(center + fwidth);
        left := floor(center - fwidth);
        right := ceil(center + fwidth);
        for j := left to right do begin
          weight := Lanczos3Filter(center - j);
          if (weight = 0.0) then continue;
          if (j < 0) then n := -j
          else if (j >= SrcHeight) then n := SrcHeight - j + SrcHeight - 1
          else n := j;
          k := contrib^[i].n;
          contrib^[i].n := contrib^[i].n + 1;
          contrib^[i].p^[k].pixel := n;
          contrib^[i].p^[k].weight := weight;
        end;
      end;
    end;

    // --------------------------------------------------
    // Apply filter to sample vertically from Work to Dst
    // --------------------------------------------------
    SourceLine := Work.ScanLine[0];
    Delta := integer(Work.ScanLine[1]) - integer(SourceLine);
    DestLine := Dst.ScanLine[0];
    DestDelta := integer(Dst.ScanLine[1]) - integer(DestLine);
    for k := 0 to DstWidth-1 do begin

      DestPixel := pointer(DestLine);
      for i := 0 to DstHeight-1 do begin
        rgb.r := 0;
        rgb.g := 0;
        rgb.b := 0;
        // weight := 0.0;
        for j := 0 to contrib^[i].n-1 do begin
          color := PColorRGB(integer(SourceLine)+contrib^[i].p^[j].pixel*Delta)^;
          weight := contrib^[i].p^[j].weight;
          if (weight = 0.0) then continue;
          rgb.r := rgb.r + color.r * weight;
          rgb.g := rgb.g + color.g * weight;
          rgb.b := rgb.b + color.b * weight;
        end;
        if (rgb.r > 255.0) then color.r := 255
        else if (rgb.r < 0.0) then color.r := 0
        else color.r := round(rgb.r);
        if (rgb.g > 255.0) then color.g := 255
        else if (rgb.g < 0.0) then color.g := 0
        else color.g := round(rgb.g);
        if (rgb.b > 255.0) then color.b := 255
        else if (rgb.b < 0.0) then color.b := 0
        else color.b := round(rgb.b);
        DestPixel^ := color;
        inc(integer(DestPixel), DestDelta);
      end;
      Inc(SourceLine,1);
      Inc(DestLine,1);
    end;

    // Free the memory allocated for vertical filter weights
    for i := 0 to DstHeight-1 do FreeMem(contrib^[i].p);
    FreeMem(contrib);
    ok:=true;

  finally
    Work.Free;

    if not ok then begin
      application.messagebox(
        'OptThumb misslungen',
        '*** FEHLER **',
        mb_ok
      );
    end;
  end;
end;

//------------------------------------------------------------------------
//""kernel" of PicOfPics
//
//- transform orginal pic to pixelbmp with quad-dimension
//- find a quad with best color to every pixel in pixelbmp
//- paint founded quads on result-bmp
//
//------------------------------------------------------------------------
procedure op_picofpics;
var
  zbmp,quadbmp,thquadbmp:tbitmap;
  qvert,qhorz,qw,qh,
  rr,px,py,x,y:integer;
  qcol:tcolor;
  fn:string;
  rec:trect;
  jpg:tjpegimage;
  breakok:bool;
  helligkeit,
  verlauf:integer;
  in_hellbereich:bool;
  pba:pbytearray;

  //paint founded quad to target bmp
  procedure setquader(l,t:integer);
  var
    w,h:integer;
  begin
    w:=hauptf.op_qbreitese.value;h:=w;

    //randomize quad dimension
    l:=l+hauptf.verwackeln(w,hauptf.op_wxse.value);
    w:=w+hauptf.verwackeln(w,hauptf.op_wwse.value);
    t:=t+hauptf.verwackeln(h,hauptf.op_wyse.value);
    h:=h+hauptf.verwackeln(h,hauptf.op_whse.value);

    //copy quad to target
    if hauptf.op_qqualicb.itemindex=0 then begin
      //super-quality
      quadbmp.assign(jpg);

      //make a fine thumb
      thquadbmp.width:=w;
      thquadbmp.Height:=h;
      op_optthumb(quadbmp,thquadbmp);

      //copy thumb to target
      zbmp.Canvas.Draw(l,t,thquadbmp);

    end
    else begin
      //do only window-stretch-draw
      rec:=rect(l,t,l+w,t+h);
      zbmp.Canvas.StretchDraw(rec,jpg);
    end;

    if hauptf.op_qrandchb.checked then begin
      //quader will have a border
      zbmp.Canvas.Pen.Width:=1;

      //border on top and left
      zbmp.Canvas.pen.color:=
        hauptf.op_qrandolsh.brush.color;
      zbmp.canvas.MoveTo(l,t  );
      zbmp.canvas.lineto(l,t+h);
      zbmp.canvas.MoveTo(l,t  );
      zbmp.canvas.lineto(l+w,t);

      //border on bottom and right
      zbmp.Canvas.pen.color:=
        hauptf.op_qrandursh.brush.color;
      zbmp.canvas.MoveTo(l+w-1,t+h-1);
      zbmp.canvas.lineto(l,    t+h-1);
      zbmp.canvas.MoveTo(l+w-1,t+h-1);
      zbmp.canvas.lineto(l+w-1,t    );
    end;
  end;

begin
  screen.Cursor:=crhourglass;

  //real random-mode
  randomize;

  //original to pixelbmp with quad-dimension
  ob_u.ob_mkpixelbmp(false);

  //define some "help"-images
  jpg:=tjpegimage.Create;
  zbmp:=tbitmap.create;
  quadbmp:=tbitmap.create;
  thquadbmp:=tbitmap.create;
  thquadbmp.PixelFormat:=pf24bit;

  //reset sum of color-errors
  hauptf.op_erre.text:='0';

  try

    //set jpg-scale-quality
    if hauptf.op_qqualicb.itemindex=0 then begin
      //super-quality
      jpg.scale:=jsFullSize;
    end
    else begin
      jpg.scale:=tjpegscale(
        hauptf.op_qqualicb.ItemIndex-1
      );
    end;

    //quad-dimension
    qhorz:=hauptf.op_qhorzse.value;
    qvert:=strtoint(hauptf.op_qverte.text);
    qw:=hauptf.op_qbreitese.value;
    qh:=qw;

    //init target bmp
    zbmp.PixelFormat:=pf24bit;
    zbmp.Width:=qhorz*qw;
    zbmp.height:=qvert*qh;

    if hauptf.op_backpicchb.checked then begin
      //target-background is original
      rec:=rect(0,0,zbmp.width,zbmp.height);
      zbmp.Canvas.StretchDraw(rec,hauptf.ob_bmp);
    end
    else begin
      //target-background is plane color
      zbmp.canvas.brush.color:=hauptf.op_backsh.Brush.Color;
      zbmp.canvas.pen.color:=hauptf.op_backsh.Brush.Color;
      zbmp.Canvas.Brush.Style:=bssolid;
      zbmp.Canvas.Rectangle(0,0,zbmp.width,zbmp.height);
    end;

    //bool for manually break
    breakok:=false;

    //Find best top-x quader for
    //every pixel of pixelbmp

    //adapt progressbar to 100 steps
    hauptf.op_prgb.Max:=qvert;
    rr:=qvert div 100;
    if rr=0 then rr:=1;

    //work on pixelmap in height
    py:=0;
    for y:=0 to qvert-1 do begin

      //set progressbar
      if y mod rr=0 then
        hauptf.op_prgb.Position:=y;
      application.processmessages;

      //manually break?
      if hauptf.op_mkpicb.caption<>'STOPP' then begin
        breakok:=true;
        break;
      end;

      //get line of colors in pixelbmp
      pba:=hauptf.ob_pixelbmp.scanline[y];

      //work on pixelmap in width
      px:=0;
      for x:=0 to qhorz-1 do begin

        //random setting of quads
        if random(100)<hauptf.op_malwkse.value then begin

          //get color you fant to replace thru quad-pic
          if not hauptf.op_verlaufchb.checked then begin
            //normal-mode: replace only one pixel
            qcol:=hauptf.pba2col(pba,x);
          end
          else begin
            //smooth-mode: replace group of 3 x 3 pixels
            qcol:=qp_u.qp_middlecolor(
              hauptf.ob_pixelbmp,
              x*3,y*3,3,3
            );
          end;

          //is gray-value of the color in chosen limits?
          helligkeit:=hauptf.col2helligkeit(qcol);
          in_hellbereich:=
            (helligkeit>=hauptf.op_hellvonsb.position)and
            (helligkeit<=hauptf.op_hellbissb.position);
          if
            ((hauptf.op_hellmodecb.itemindex=0)and in_hellbereich)or
            ((hauptf.op_hellmodecb.itemindex=1)and not in_hellbereich)
          then begin

            //ok: find the best quad-pic in quad-grid
            fn:=op_col2sgfn(qcol,x*3,y*3);

            //load the founded quad
            jpg.LoadFromFile(fn);

            //copy quad to target bmp
            setquader(px,py);
          end;
        end;

        //increase target-position with quader-width
        px:=px+qw;
      end;

      //increase target-position with quader-height
      py:=py+qh;

      //preview?
      if hauptf.op_prevchb.Checked then begin
        op_mkprevbmp(zbmp);
        hauptf.op_prevpbpaint(nil);
      end;
    end;

    //copy created target bmp to result
    hauptf.eb_bmp.assign(zbmp);

    //set hint-informations
    hauptf.eb_pb.Hint:=
      inttostr(zbmp.width)+
      ' x '+
      inttostr(zbmp.Height)+
      ' Pixel';
    hauptf.eb_pb.showhint:=true;

    //reset scrollbars an size of result-image
    hauptf.eb_hsb.Position:=0;
    hauptf.eb_vsb.Position:=0;
    eb_u.eb_orgsz;

    //copy result to result-paintbox
    eb_u.eb_paintboxpaint;

    //set merge-base to created target-pic
    hauptf.eb_blendbmp.assign(zbmp);

    //save target-pic (quad-pic)
    hauptf.eb_quadbmp.assign(zbmp);

    //save original for merging
    hauptf.eb_orgbmp.Width:=zbmp.width;
    hauptf.eb_orgbmp.height:=zbmp.height;
    rec:=rect(0,0,zbmp.width,zbmp.height);
    hauptf.eb_orgbmp.Canvas.StretchDraw(rec,hauptf.ob_bmp);

    //opts of result to default
    hauptf.eb_hellmodecb.itemindex:=0;
    hauptf.eb_hellvonsb.Position:=0;
    hauptf.eb_hellbissb.Position:=255;
    hauptf.eb_blendorgrb.checked:=true;
    hauptf.eb_blendmodecb.ItemIndex:=0;
    hauptf.eb_blendsb.Position:=0;

    //manually break?
    if not breakok then begin
      //no: adapt preview
      op_updateprev;
      //change to result-page of page control
      hauptf.pctrl.ActivePage:=hauptf.eb_ts;
    end;

    //adapt sum of color-errors
    verlauf:=1;
    if hauptf.op_verlaufchb.checked then
      verlauf:=9;
    hauptf.op_erre.Text:=format(
      '%f',
      [
        strtoint64(hauptf.op_erre.Text)/
        (qhorz*qvert*verlauf)
      ]
    );

  finally
    //clean up the shit
    quadbmp.Free;
    zbmp.Free;
    jpg.Free;
    hauptf.op_prgb.Position:=0;
    screen.Cursor:=crdefault;
  end;
end;

//make preview-bmp: original width quads as pixels
procedure op_mkprevbmp(zbmp:tbitmap);

  //convert int to byte------------
  function i2b(i:integer):byte;
  begin
    if i<0 then i:=0;
    if i>255 then i:=255;
    result:=byte(i);
  end;

var
  ql,qt,qw,qh,
  ww,hh,
  l,t,w,h,
  x,y,
  helligkeit,
  vy,
  yanz:integer;
  dx,dy,dvy:double;
  col:tcolor;
  in_hellbereich:bool;
  pba:pbytearray;
  r,g,b,rc,gc,bc:byte;
begin
  if not hauptf.visible then exit;

  //for optimation
  inc(hauptf.cc_updateprevc);hauptf.countercheck;

  //set preview-bmp dimension to paintbox-dimension
  hauptf.op_prevbmp.Width:=hauptf.op_prevpb.width;
  hauptf.op_prevbmp.height:=hauptf.op_prevpb.height;

  //paint plane background
  hauptf.op_prevbmp.Canvas.Brush.color:=clsilver;
  hauptf.op_prevbmp.Canvas.FillRect(
    rect(
      0,
      0,
      hauptf.op_prevbmp.width,
      hauptf.op_prevbmp.height
    )
  );

  //preview mode?
  if not hauptf.op_prevchb.checked then exit;

  //is there an original-pic?
  if ob_u.ob_isempty then exit;

  //get dimension of inner preview-pic in paintbox
  hauptf.getinnerbounds(
    hauptf.op_prevpb.Width,
    hauptf.op_prevpb.height,
    hauptf.ob_bmp.width,
    hauptf.ob_bmp.height,
    l,t,w,h
  );

  //save width and hight
  ww:=w;
  hh:=h;

  //creating the result-pic?
  if zbmp<>nil then begin
    //copy actually pic to result-bitmap
    hauptf.op_prevbmp.Canvas.StretchDraw(
      rect(l,t,l+w,t+h),
      zbmp
    );
    exit;
  end;

  //only a preview depends on options---------------
  randseed:=123;

  //convert original to (small) pixelbmp
  //=> every pixel stands for a quad
  ob_u.ob_mkpixelbmp(true);

  if hauptf.op_backpicchb.checked then begin
    //original as background
    hauptf.op_prevbmp.Canvas.StretchDraw(
      rect(l,t,l+w,t+h),
      hauptf.ob_bmp
    );
  end
  else begin
    //set background-color
    hauptf.op_prevbmp.Canvas.Brush.color:=
      hauptf.op_backsh.Brush.color;
    hauptf.op_prevbmp.Canvas.FillRect(
      rect(l,t,l+w,t+h)
    );
  end;


  //paint dummy-quads on preview--------------------

  //calculate width of a quad on preview
  dx:=w/hauptf.op_qhorzse.value;

  //calculate hight of a quad on preview
  yanz:=strtoint(hauptf.op_qverte.text);
  dy:=h/yanz;

  //transform dimension from float to int
  w:=trunc(dx);
  h:=trunc(dy);

  //border_color: black as default
  hauptf.op_prevbmp.Canvas.brush.style:=bssolid;
  hauptf.op_prevbmp.Canvas.pen.width:=1;
  hauptf.op_prevbmp.Canvas.pen.color:=clblack;

  for y:=0 to yanz-1 do begin
    //calc top of actually quad on preview
    qt:=trunc(y*dy);

    //get line of colors
    pba:=hauptf.ob_pixelbmp.scanline[y];

    for x:=0 to hauptf.op_qhorzse.value-1 do begin

      //set quad randomly
      if random(100)>hauptf.op_malwkse.value then continue;

      //calc left of actually quad on preview
      ql:=trunc(x*dx);

      //get pixel-color
      col:=hauptf.pba2col(pba,x);

      //is gray-value of the color in chosen limits?
      helligkeit:=hauptf.col2helligkeit(col);
      in_hellbereich:=
        (helligkeit>=hauptf.op_hellvonsb.position)and
        (helligkeit<=hauptf.op_hellbissb.position);
      if
        ((hauptf.op_hellmodecb.itemindex=0)and not in_hellbereich)or
        ((hauptf.op_hellmodecb.itemindex=1)and in_hellbereich)
      then continue;


      //quader dimension randomazation
      ql:=ql+hauptf.verwackeln(w,hauptf.op_wxse.value);
      qt:=qt+hauptf.verwackeln(h,hauptf.op_wyse.value);
      qw:=w+hauptf.verwackeln(w,hauptf.op_wwse.value);
      qh:=h+hauptf.verwackeln(h,hauptf.op_whse.value);

      if hauptf.op_verlaufchb.Checked then begin

        //no border? Then border color=brush color
        if not hauptf.op_qrandchb.checked then
          hauptf.op_prevbmp.Canvas.pen.Color:=col;

        r:=getrvalue(col);
        g:=getgvalue(col);
        b:=getbvalue(col);

        dvy:=qh/3;
        for vy:=0 to 2 do begin
          rc:=i2b(r+random(30)-random(30));
          gc:=i2b(g+random(30)-random(30));
          bc:=i2b(b+random(30)-random(30));
          col:=rgb(rc,gc,bc);
          hauptf.op_prevbmp.Canvas.brush.Color:=col;
          hauptf.op_prevbmp.Canvas.pen.Color:=col;
          hauptf.op_prevbmp.Canvas.rectangle(
            l+ql,t+qt+trunc(vy*dvy),
            l+ql+qw,t+qt+trunc(vy*dvy+dvy)
          );
        end;

        if hauptf.op_qrandchb.checked then begin
          hauptf.op_prevbmp.Canvas.pen.color:=clblack;
          hauptf.op_prevbmp.Canvas.brush.style:=bsclear;
          hauptf.op_prevbmp.Canvas.rectangle(
            l+ql,t+qt,l+ql+qw,t+qt+qh
          );
          hauptf.op_prevbmp.Canvas.brush.style:=bssolid;
        end;

      end
      else begin
        //no border? Then border color=brush color
        if not hauptf.op_qrandchb.checked then
          hauptf.op_prevbmp.Canvas.pen.Color:=col;
        hauptf.op_prevbmp.Canvas.brush.Color:=col;

        //paint the dummy-quad on preview
        hauptf.op_prevbmp.Canvas.rectangle(
          l+ql,t+qt,l+ql+qw,t+qt+qh
        );
      end;
    end;
  end;

  if not hauptf.op_wackelchb.Checked then exit;

  //to repaint quads out of inner frame
  hauptf.op_prevbmp.Canvas.Brush.color:=clsilver;

  hauptf.op_prevbmp.Canvas.FillRect(
    rect(0,0,hauptf.op_prevbmp.width,t-1)
  );
  hauptf.op_prevbmp.Canvas.FillRect(
    rect(0,0,l-1,hauptf.op_prevbmp.height)
  );
  hauptf.op_prevbmp.Canvas.FillRect(
    rect(l+ww+1,0,hauptf.op_prevbmp.width,hauptf.op_prevbmp.height)
  );
  hauptf.op_prevbmp.Canvas.FillRect(
    rect(0,t+hh+1,hauptf.op_prevbmp.width,hauptf.op_prevbmp.height)
  );

end;

end.

