unit qp_u;

{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, jpeg, ExtDlgs, Menus, ComCtrls,
  inifiles,Grids, Spin,Buttons,FileCtrl;

procedure qp_setheadsg;
procedure qp_ldimg;
procedure qp_sgClick;
procedure qp_clrsg;
procedure qp_rdsg;
procedure qp_wrsg;
procedure qp_mkhistoimg;
procedure qp_fillsg;
procedure qp_sgDrawCell(
  Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState
);
function qp_isempty:bool;
procedure qp_sethistocursor;
function qp_middlecolor(bmp:tbitmap;l,t,w,h:integer):tcolor;

implementation

uses hauptu,op_u;

//set head of quad-grid-----------------
procedure qp_setheadsg;
begin
  hauptf.qp_sg.Cells[ord(_qp_nr),0]:='Nr';
  hauptf.qp_sg.Cells[ord(_qp_fn),0]:='Bild';
  hauptf.qp_sg.Cells[ord(_qp_farbe),0]:='Mittel';
  hauptf.qp_sg.Cells[ord(_qp_verlauf11),0]:='Verlauf';
end;

//delete quad-grid-------------------------
procedure qp_clrsg;
var
  c:integer;
begin
  for c:=0 to ord(_qp_c)-1 do
    hauptf.qp_sg.cols[c].Clear;

  hauptf.qp_sg.rowcount:=2;
  hauptf.qp_sg.ColCount:=ord(_qp_verlauf11)+1;
  qp_setheadsg;

  //delete histogram
  qp_mkhistoimg;

  //new quad-preview
  qp_sgClick;
  hauptf.setbuttons;
end;

//middlecolor of "inner" bitmap
function qp_middlecolor(
  bmp:tbitmap;
  l,t,w,h:integer
):tcolor;
var
  anz,x,y:integer;
  //col:tcolor;
  rc,gc,bc:int64;
  pba:pbytearray;
begin
  rc:=0;gc:=0;bc:=0;
  for y:=t to t+h-1 do begin
    pba:=bmp.scanline[y];
    for x:=l to l+w-1 do begin
      //add colors of red,green,blue
      rc:=rc+pba[x*3+2];
      gc:=gc+pba[x*3+1];
      bc:=bc+pba[x*3+0];
    end;
  end;

  //calculate middle of color-sums
  anz:=w*h;
  rc:=round(rc/anz);
  gc:=round(gc/anz);
  bc:=round(bc/anz);

  //give back middle color
  result:=rgb(rc,gc,bc);
end;

//fill quad-grid with colors auf quad-pics
procedure qp_fillsg;

  //get quality-value for quad-pic
  //(smaller pics wil set to better quality)
  function optscale(jpg:tjpegimage):tjpegscale;
  var
    w,h:integer;
  begin
    w:=jpg.width;
    h:=jpg.height;
    result:=jsEighth;
    if (h<8)or(w<8) then
      result:=jsfullsize
    else if (h<50)or(w<50) then
      result:=jshalf
    else if (h<400)or(w<400) then
      result:=jsquarter;
  end;

  //get and set smooth-colors in quad-grid
  procedure setverlaufcolors(
    bmp,pixelbmp:tbitmap;
    r:integer
  );
  var
    c,x,y:integer;
    pba:pbytearray;
  begin
    //reduce quad-pic to 3 x 3 pixels
    pixelbmp.canvas.StretchDraw(rect(0,0,3,3),bmp);

    //pixel-colors into quad-grid
    c:=ord(_qp_verlauf11);
    for y:=0 to 2 do begin
      pba:=pixelbmp.scanline[y];
      for x:=0 to 2 do begin
        hauptf.qp_sg.cells[c,r]:=
          inttostr(hauptf.pba2col(pba,x));
        inc(c);
      end;
    end;
  end;

var
  r,rr:integer;
  jpg:tjpegimage;
  bmp,pixelbmp:tbitmap;
begin
  if hauptf.qp_neub.Caption='Neu' then begin
    screen.cursor:=crhourglass;
    hauptf.qp_neub.Caption:='STOPP';
    qp_clrsg;

    jpg:=tjpegimage.Create;
    bmp:=tbitmap.Create;
    pixelbmp:=tbitmap.Create;
    try
      //pixelbmp-dimension 3 x 3
      pixelbmp.PixelFormat:=pf24bit;
      pixelbmp.Width:=3;
      pixelbmp.Height:=3;

      //bitmap-holder fuer jpg
      bmp.PixelFormat:=pf24bit;

      hauptf.qp_prgb.Max:=hauptf.qp_flb.items.count-1;
      rr:=1;
      for r:=0 to hauptf.qp_flb.items.count-1 do begin
        try
          hauptf.qp_flb.itemindex:=r;
          hauptf.qp_prgb.position:=r;
          application.processmessages;
          if hauptf.qp_neub.Caption<>'STOPP' then
            break;

          //read pic
          jpg.Scale:=jsfullsize;
          jpg.LoadFromFile(
            hauptf.qp_dlb.directory+'\'+
            hauptf.qp_flb.items[r]
          );

          //set quality (depends on size)
          //jpg.Scale:=optscale(jpg);

          //convert to bmp
          bmp.Assign(jpg);

          //calculate middle-color
          hauptf.qp_sg.cells[ord(_qp_farbe),rr]:=
            inttostr(
              qp_middlecolor(
                bmp,
                0,0,bmp.Width,bmp.height
              )
            );
          hauptf.qp_sg.cells[ord(_qp_nr),rr]:=inttostr(rr);
          hauptf.qp_sg.cells[ord(_qp_fn),rr]:=hauptf.qp_flb.items[r];

          //set smooth-colors
          setverlaufcolors(bmp,pixelbmp,rr);

          inc(rr);
        except
          //ignore bad pics
        end;
      end;

      //adapt quad-grid-rowcount
      if rr=1 then rr:=2;
      hauptf.qp_sg.RowCount:=rr;

      //save quad-grid
      qp_wrsg;

      //build histogram
      qp_mkhistoimg;

      //check first entry
      hauptf.qp_sg.Row:=1;
      qp_sgClick;

      //clean up
      hauptf.qp_prgb.position:=0;
      hauptf.qp_neub.Caption:='Neu';
    finally
      pixelbmp.free;
      bmp.Free;
      jpg.Free;
      op_updateprev;
      hauptf.setbuttons;
      screen.cursor:=crdefault;
    end;
  end
  else begin
    //stopp-button clicked
    hauptf.qp_neub.Caption:='Neu';
  end;
end;

//check if quad-grid is empty
function qp_isempty:bool;
begin
  result:=(hauptf.qp_sg.cells[ord(_qp_fn),1]='');
end;

//reading quader-sg from disk------------------------
procedure qp_rdsg;
var
  r,c,cc:integer;
  tf:textfile;
  fn,s,ss:string;
begin
  //reset quad-pool.grid
  qp_clrsg;

  //read quad-sg from file
  if fileexists(hauptf.homedir+_qpfn)then begin
    r:=0;
    assignfile(tf,hauptf.homedir+_qpfn);
    try
      reset(tf);
      while not eof(tf) do begin
        readln(tf,s);
        for c:=0 to ord(_qp_c) do begin
          cc:=pos('|',s);if cc=0 then cc:=length(s)+1;
          ss:=copy(s,1,cc-1);
          hauptf.qp_sg.cells[c,r]:=ss;
          s:=copy(s,cc+1,length(s));
        end;
        inc(r);
      end;
    finally
      closefile(tf);
    end;

    //adapt rowcount of quad-grid
    if r<2 then r:=2;
    hauptf.qp_sg.rowcount:=r;

    //check quad-pics <-> picture-liste in directory
    for r:=hauptf.qp_sg.rowcount-1 downto 1 do begin
      fn:=
        hauptf.qp_dlb.directory+'\'+
        hauptf.qp_sg.cells[ord(_qp_fn),r];

      //ok?
      if fileexists(fn) then continue;

      //no - quad does not exitsts
      if hauptf.qp_sg.rowcount>2 then begin
         //del row in quad-grid
         hauptf.qp_sg.rows[r].clear;
      end
      else begin
        //del entry, but keep the row
        for c:=0 to ord(_qp_c)-1 do
          hauptf.qp_sg.cells[c,r]:='';
      end;
    end;

    //quad-grid totally empty?
    if qp_isempty then qp_clrsg;

    //save to disk
    qp_wrsg;

    //show histogram
    qp_mkhistoimg;
    qp_sgclick;
  end;
end;

//write quad-grid to disk--------------------
procedure qp_wrsg;
var
  tf:textfile;
  r,c:integer;
  s:string;
begin
  //del previous quad-pool
  deletefile(hauptf.homedir+_qpfn);

  //if quad-grid is empty, nothing to do
  if qp_isempty then exit;

  //save grid as textfile
  assignfile(tf,hauptf.homedir+_qpfn);
  try
    rewrite(tf);
    for r:=0 to hauptf.qp_sg.RowCount-1 do begin
      s:='';
      for c:=0 to ord(_qp_c)-1 do begin
        s:=s+hauptf.qp_sg.cells[c,r]+'|';
      end;
      writeln(tf,s);
    end;
  finally
    closefile(tf);
  end;
end;

//create histogram over all quad-pics-----------------
procedure qp_mkhistoimg;
var
  ca:array[0..256]of double;
  c,r,helligkeit:integer;
  col:tcolor;
begin
  //reset gray-color-array
  for c:=0 to 255 do ca[c]:=0;

  //quad loaded?
  if not qp_isempty then begin
    for r:=1 to hauptf.qp_sg.rowcount-1 do begin
      //get color-entry of quad-grid
      col:=tcolor(
        strtoint(
          hauptf.qp_sg.cells[ord(_qp_farbe),r]
        )
      );

      //convert color-value to gray-color
      helligkeit:=hauptf.col2helligkeit(col);

      //increase counter in gray-array
      ca[helligkeit]:=ca[helligkeit]+1;
    end;

    //save back values of gray-array
    for c:=0 to 255 do
      hauptf.qp_histoa[c]:=ca[c];

    //want a logarithm norm of values?
    if hauptf.qp_logchb.checked then begin
      for c:=0 to 255 do
        ca[c]:=ln(1+ca[c]);
    end;
  end;

  //transfer gray-array to bitmap
  hauptf.mkhistoimg(
    hauptf.qp_histoimg,ca
  );

  //save histogram
  hauptf.qp_histobmp.assign(
    hauptf.qp_histoimg.Picture
  );
end;

//click at quad-grid-exntry----------------
procedure qp_sgClick;
var
  r:integer;
  fn:string;
begin
  r:=hauptf.qp_sg.row;
  fn:=hauptf.qp_sg.cells[ord(_qp_fn),r];
  r:=hauptf.qp_flb.Items.IndexOf(fn);
  hauptf.qp_flb.Itemindex:=r;
  qp_ldimg;
end;

//load quad-pic-------------------------
procedure qp_ldimg;
var
  r:integer;
  fn:string;
begin
  try
    hauptf.qp_img.Picture.Graphic:=nil;
    r:=hauptf.qp_flb.ItemIndex;
    if r=-1 then exit;

    fn:=hauptf.qp_flb.Items[r];
    try
      //file in quad-grid?
      for r:=1 to hauptf.qp_sg.RowCount-1 do begin
        if hauptf.qp_sg.cells[ord(_qp_fn),r]<>fn then
          continue;

        //mark entry-row
        hauptf.qp_sg.col:=ord(_qp_fn);
        hauptf.qp_sg.row:=r;
        break;
      end;

      //read from disk
      hauptf.qp_img.picture.loadfromfile(
        hauptf.qp_dlb.Directory+'\'+fn
      );
    except
      //shit happens
      hauptf.qp_img.Picture.Graphic:=nil;
    end;
  finally
    //set "cursor" on histogram
    qp_sethistocursor;
  end;
end;

//set "cursor" on histogramm--------------
//(gray-value of actually quad-pic)
procedure qp_sethistocursor;
var
  x,helligkeit,hfg:integer;
  bmp:tbitmap;
  col:tcolor;
  hfgproz:double;
  s:string;
begin
  hauptf.qp_sh.brush.color:=clsilver;
  hauptf.qp_helle.Text:='';
  hauptf.qp_haeufe.Text:='';

  if qp_isempty then exit;

  bmp:=tbitmap.create;
  try
    //get original histogram
    bmp.assign(hauptf.qp_histobmp);

    //get middle-color
    col:=strtoint(
      hauptf.qp_sg.cells[ord(_qp_farbe),hauptf.qp_sg.Row]
    );
    hauptf.qp_sh.Brush.color:=col;

    //calculate gray-value
    helligkeit:=hauptf.col2helligkeit(col);
    hauptf.qp_helle.Text:=inttostr(helligkeit);

    //number of that gray-value in histogram
    hfg:=trunc(hauptf.qp_histoa[helligkeit]);
    s:=inttostr(hfg);
    hfgproz:=(hfg*100)/(hauptf.qp_sg.RowCount-1);
    s:=s+' ('+format('%f',[hfgproz])+'%)';
    hauptf.qp_haeufe.Text:=s;

    //"cursor"-line for histogram
    x:=helligkeit;
    bmp.canvas.pen.width:=1;
    bmp.canvas.pen.color:=clgreen;
    bmp.Canvas.MoveTo(x,0);
    bmp.Canvas.lineTo(x,bmp.height);

  finally
    //show (new) histogram
    hauptf.qp_histoimg.picture.assign(bmp);
    bmp.free;
  end;
end;

//painting the quad-grid-rcells--------------------------
procedure qp_sgDrawCell(
  Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState
);
var
  s:string;
  c,l,t,w,x,y:integer;
  cnv:tcanvas;
  rec:trect;
  dw,dh:double;
begin

  cnv:=hauptf.qp_sg.Canvas;
  s:=hauptf.qp_sg.cells[acol,arow];

  try
    //background color
    if state=[] then begin
      //not marked: set own color
      if acol=ord(_qp_fn) then
        cnv.brush.color:=clwhite
      else if acol=ord(_qp_farbe) then
        cnv.brush.color:=strtoint(s)
      else if acol=ord(_qp_verlauf11) then begin

        //paint a 3x3 color pattern
        c:=ord(_qp_verlauf11);
        dw:=(rect.Right-rect.Left)/3;
        dh:=(rect.Bottom-rect.Top)/3;

        for y:=0 to 2 do begin
          for x:=0 to 2 do begin
            cnv.brush.color:=strtoint(
              hauptf.qp_sg.cells[c,arow]
            );

            rec.Left:=rect.Left+trunc(x*dw);
            rec.Right:=rec.left+trunc(dw);

            rec.top:=rect.top+trunc(y*dh);
            rec.bottom:=rec.top+trunc(dh);

            cnv.FillRect(rec);
            inc(c);
          end;
        end;
        exit;
      end;
    end;
    cnv.FillRect(rect);

    //dont show values of color-entries
    if(arow>0)and(acol>=ord(_qp_farbe))then exit;

    //text-aligment
    if acol=ord(_qp_nr) then begin
      //right
      w:=cnv.textwidth(s);
      l:=rect.Right-w-4;
    end
    else begin
      //left
      l:=rect.left+2;
    end;

    //place it in the middle
    t:=
      rect.Top+
      (
        (
          rect.Bottom-
          rect.Top-
          cnv.textheight(s)
        ) div 2
      );

    //paint text
    cnv.TextOut(l,t,s);
  except
  end;
end;


end.

